/**
  **********************************************************************************
  * @file      ebyte_port.h
  * @brief     EBYTEӲӿڲ ɿͻԼṩIOӿ    
  * @details   μ https://www.ebyte.com/       
  * @author    JiangHeng     
  * @date      2021-05-13     
  * @version   1.0.0     
  **********************************************************************************
  * @copyright BSD License 
  *            ɶڰصӿƼ޹˾  
  *   ______   ____   __     __  _______   ______ 
  *  |  ____| |  _ \  \ \   / / |__   __| |  ____|
  *  | |__    | |_) |  \ \_/ /     | |    | |__   
  *  |  __|   |  _ <    \   /      | |    |  __|  
  *  | |____  | |_) |    | |       | |    | |____ 
  *  |______| |____/     |_|       |_|    |______| 
  *
  **********************************************************************************
  */
#include "ebyte_port.h"


/*= !!!ĿӲƽ̨ͷļ =======================================*/
#include "board.h"  //E15-EVB02 
/*==================================================================*/
#define NULL 0
/* !
 * @brief ĿӲƽ̨SPIӿշ 
 * 
 * @param send EBYTEϲҪ 1 Byte 
 * @return SPIյ 1 Byte
 * @note Ŀƽ̨ӲSPI_NSSʱ ebyte_conf.hļ رSPI_CS(NSS)
 *       Ŀƽ̨SPI_NSSʱ Ebyte_Port_SpiCsIoControl() ĺ˵
 */
uint8e_t Ebyte_Port_SpiTransmitAndReceivce( uint8e_t send )
{
    uint8e_t result = 0;
    
    /* !ṩ: SPIӿ */
    result = Ebyte_BSP_SpiTransAndRecv( send );
    
    return result;
}

/* !
 * @brief (ѡ)ĿӲƽ̨SPI_CS(NSS) 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: CS(NSS)͵ƽ߼ź EBYTEģSPIӿΪ͵ƽѡ
 *            @arg 1: CS(NSS)ߵƽ߼ź
 * @note Ŀƽ̨ӲSPI_NSSʱļ ˺Ч
 *       Ŀƽ̨SPI_NSSʱô˺
 */
void Ebyte_Port_SpiCsIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
       /* !ѡ: SPI CS E22xxߵƽδѡ */  
       Ebyte_BSP_RfSpiUnselected(); 
    }
    else
    {
       /* !ѡ: SPI CS E22xx͵ƽѡ */  
       Ebyte_BSP_RfSpiSelected( );
    }
}

/* !
 * @brief ĿӲƽ̨λ NRST ƺ 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: NRST ͵ƽ߼ź 
 *            @arg 1: NRST ߵƽ߼ź
 * @note EBYTEģNRSTΪ͵ƽλ
 */
void Ebyte_Port_RstIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
        /* !ṩ: NRSTIO ߵƽ */
        Ebyte_BSP_RfResetIoHigh();
    }
    else
    {
        /* !ṩ: ĿӲ·ӦNRSTIO ͵ƽ */
        Ebyte_BSP_RfResetIoLow();
    }
}

/* !
 * @brief (ѡ)ĿӲƽ̨ʹ TXEN ƺ 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: TXEN ͵ƽ߼ź 
 *            @arg 1: TXEN ߵƽ߼ź 
 * @note EBYTEģTXENΪߵƽЧ
 *       Ŀƽ̨ģDIO2ԶTXENʱ˺Ч
 */
void Ebyte_Port_TxenIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
        /* !ѡ: ĿӲ·ӦTXENIO ߵƽ */
        Ebyte_BSP_RfTxIoEnable();
    }
    else
    {
        /* !ѡ: ĿӲ·ӦTXENIO ͵ƽ */
        Ebyte_BSP_RfTxIoDisable();
    }
}

/* !
 * @brief ĿӲƽ̨ʹ RXEN ƺ 
 * 
 * @param cmd EBYTEϲĿָ
 *            @arg 0: RXEN͵ƽ߼ź 
 *            @arg 1: RXENߵƽ߼ź 
 * @note EBYTEģRXENΪߵƽЧ
 */
void Ebyte_Port_RxenIoControl( uint8e_t cmd )
{
    if ( cmd == 1 )
    {
        /* !ṩ: ĿӲ·ӦRXENIO ߵƽ */
        Ebyte_BSP_RfRxIoEnable();
    }
    else
    {
        /* !ṩ: ĿӲ·ӦRXENIO ͵ƽ */
        Ebyte_BSP_RfRxIoDisable();
    }
}

/* !
 * @brief ĿӲƽ̨ʹ BUSY ƺ 
 * 
 * @note EBYTEģBUSYΪߵƽʾæ
 */
uint8e_t Ebyte_Port_BusyIoRead( void )
{
    uint8e_t result = 0 ;  
    
    /* !ṩ: ĿӲ·ӦBUSY IO ״̬ȡ */
    result = Ebyte_BSP_RfBusyIoRead();
    return result;
}

/* !
 * @brief ĿӲƽ̨ʱ
 * 
 * @param time ʱ 
 * @note עʱģʼʱô˺עжǷӰ쵽˺
 */
void Ebyte_Port_DelayMs( uint16e_t time )
{
    /* !ṩ: ʱ */
  
    uint16e_t i,n;
    
    while(time--)//ʾSTM8L 16MʱǰµĴʱ 
    {
        for(i=900;i>0;i--)
        {
              for( n=1 ;n>0 ;n--)
              {
                  asm("nop"); 
                  asm("nop");
                  asm("nop");
                  asm("nop");
              }
        }
    }    
}


void * __memcpy(void *dest, void *src, int num)
{
	if((dest == NULL) ||(src == NULL))
	{
		DEBUG("parameter error!\n");
		return 0;
	}
 
	char *pdest;
	char *psrc;
	pdest = dest;
	psrc = src;
	while(num --)
	{
		*pdest = *psrc;
		*pdest ++;
		*psrc++;
	}
	return dest;
}

 

