/**
  **********************************************************************************
  * @file      main.c
  * @brief     E15-EVB02 ̼
  * @details   Ϊ: ͸ʾ  μ https://www.ebyte.com/
  * @author    JiangHeng
  * @date      2021-05-06
  * @version   1.0.0
  **********************************************************************************
  * @copyright BSD License
  *            ɶڰصӿƼ޹˾
  *   ______   ____   __     __  _______   ______
  *  |  ____| |  _ \  \ \   / / |__   __| |  ____|
  *  | |__    | |_) |  \ \_/ /     | |    | |__
  *  |  __|   |  _ <    \   /      | |    |  __|
  *  | |____  | |_) |    | |       | |    | |____
  *  |______| |____/     |_|       |_|    |______|
  *
  **********************************************************************************
  */

#include "ebyte_core.h"
#include "ebyte_kfifo.h"
#include "ebyte_debug.h"
#include "hw3000.h"
    
void Task_Transmit( void );
void Task_Button( void );

/*  ݴ洢 */
Ebyte_FIFO_t hfifo;

/*  ֡ɱʶ */
uint8_t Uart_isRecvReady = 0;

/*  FIFOʶ */
uint8_t FIFO_isTimeCheckReady = 0;

/*  Զ/ */
uint8_t TxBuffer[64] = {0};
uint8_t RxBuffer[64] = {0};
uint8_t PcEchoBuffer[20] = {0};

uint8_t BufferPing[5] = {'p', 'i', 'n', 'g'};
uint8_t BufferPong[5] = {'p', 'o', 'n', 'g'};

/*  FIFOʶ */
uint8_t Callback_isPingCheckReady = 0;

/* Լģʽ ʶ */
uint8_t PC_isConnected = 0;

static BSP_BTN_EVENT_t BTN_Event;


/* !
 * @brief 
 */
int main( void )
{
    /* ӲԴ ʼ */
    Ebyte_BSP_Init();

    /* (ѡ) жϽFIFO ɸҪд */
    Ebyte_FIFO_Init( &hfifo, EBYTE_FIFO_SIZE );
    DEBUG( "Start PingPong.....\r\n" );
    if( Hw3000_Check_Spi() )                //SPI,оƬͨǷ
        DEBUG( "HW3000 is ready\r\n");
    else
        DEBUG( "HW3000 not find\r\n");
    Ebyte_Port_DelayMs(5);
    /* EBYTE ģʼ */
    Ebyte_RF.Init();

    /* MCU ȫж */
    Ebyte_BSP_GlobalIntEnable();
    DEBUG( "Start PingPong.....\r\n" );
    DEBUG( "Please push button1 or button2.....\r\n" );
    Hw3000Param.RFState = RX_INIT;
    while( 1 )
    {
      
      
        /* ¼Ӧ */
        Task_Button();

        /* :⴮ݲ߷ ͻ밴Զ */
        Task_Transmit();

        /* :EBYTEִ  ͻ޸ */
        Ebyte_RF.StartPollTask();
       
    }

}

/* !
 * @brief  ѯ ڽյͨģ鷢
 *
 * @note ͻҪ͵ݽҪǶߴ俪
 *       עģģʽлһ¿Դڽ//  ʾΪ: ģʽ->ģʽ->ģʽ
 */
void Task_Transmit( void )
{
    uint16_t length = 0;
    uint8_t pcEchoLength = 0;
    uint8_t pongLength = 0;

    /* ǷҪߴ (ԴڽFIFO) */
    Ebyte_FIFO_GetDataLength( &hfifo, &length );

    /* 漰첽ж,ʾ ж
       1; FIFOѾյ֡ʱ߷( ʱ֡ʽ,ʱжʱᵼճ ݾĿп֡ж )
       2: FIFOݵѾ˳˽״̬ʱ ( ᵼFIFOʣδݱ߷ ݾĿп֡ж )*/
    if( ( length != 0 && Uart_isRecvReady ) || ( length != 0 && FIFO_isTimeCheckReady ) )
    {
        Ebyte_BSP_LedControl( BSP_LED_1, ON );

        /* ȡFIFO ݷTxBuffer */
        Ebyte_FIFO_Read( &hfifo, TxBuffer, length );

        /* PCָӦ */
        if( Ebyte_DEBUG_CommandEcho( TxBuffer,length, PcEchoBuffer, &pcEchoLength ) )
        {
            Ebyte_BSP_UartTransmit( PcEchoBuffer , pcEchoLength); 
        }
        /* ָ͸ */
        else
        {
            /* ģз  */
            Ebyte_RF.Send( TxBuffer, length);

            /* ģ */
            Ebyte_RF.EnterReceiveMode();          
        }
        
        /* ÿһ֡ͼ֡ жϿѾд˶֡ */
        if( Uart_isRecvReady )  Uart_isRecvReady --;
        if( FIFO_isTimeCheckReady ) FIFO_isTimeCheckReady = 0;

        Ebyte_BSP_LedControl( BSP_LED_1, OFF );
    }
    
    /* ɻص⵽ ping  ظ pong */
    if( Callback_isPingCheckReady )
    {   
        if( PC_isConnected )
        {
            pongLength = 5;
        }else{
            DEBUG( "\r\n Echo : pong \r\n" );
            pongLength = 4;
        }
        
        /* ģз  */
        Ebyte_RF.Send( BufferPong, pongLength);

        /* ģ */
        Ebyte_RF.EnterReceiveMode();   
        
        Callback_isPingCheckReady = 0;
    }
}

/* !
 * @brief ¼Ӧ
 */
void Task_Button( void )
{
    uint8_t pcEchoLength = 0;
    uint8_t pingLength = 0;
    
    if( ! Ebyte_BTN_FIFO_Pop( &BSP_BTN_FIFO, &BTN_Event ) )
    {
        switch( BTN_Event )
        {
        /* 1 ̰ */
        case BTN_1_SHORT: 
            Ebyte_BSP_LedControl( BSP_LED_1, ON );
            
            if( PC_isConnected )
            {
               /* ֪ͨPC */
                Ebyte_DEBUG_CommandEcho( (uint8_t*)SimulatedCommandsButton1, EBYTE_CMD_PACKAGE_LENGTH , PcEchoBuffer, &pcEchoLength );
                Ebyte_BSP_UartTransmit( PcEchoBuffer , pcEchoLength); 
                BufferPing[4] = 0x01;
                pingLength = 5;
            }else
            {
                DEBUG( "\r\n Send Command : ping \r\n" );
                pingLength = 4;
            }
            
            /*  ping */
            Ebyte_RF.Send( BufferPing, pingLength);
            Ebyte_RF.EnterReceiveMode();
            
            Ebyte_BSP_LedControl( BSP_LED_1, OFF );
            break;
        /* 1  */    
        case BTN_1_LONG:
            Ebyte_BSP_LedControl( BSP_LED_1, TOGGLE );
            break;
        /* 2 ̰ */     
        case BTN_2_SHORT:
            Ebyte_BSP_LedControl( BSP_LED_2, ON );
            if( PC_isConnected )
            {
               /* ֪ͨPC */
                Ebyte_DEBUG_CommandEcho( (uint8_t*)SimulatedCommandsButton2, EBYTE_CMD_PACKAGE_LENGTH , PcEchoBuffer, &pcEchoLength );
                Ebyte_BSP_UartTransmit( PcEchoBuffer , pcEchoLength); 
                BufferPing[4] = 0x02;
                pingLength = 5;
            }else
            {
                DEBUG( "\r\n Send Command : ping \r\n" );
                pingLength = 4;
            }
            
            /*  ping */
            Ebyte_RF.Send( BufferPing, pingLength);
            Ebyte_RF.EnterReceiveMode();
            
            Ebyte_BSP_LedControl( BSP_LED_2, OFF );  
            break;
        /* 2  */     
        case BTN_2_LONG:
            Ebyte_BSP_LedControl( BSP_LED_2, TOGGLE );
            break;
        default :
            break;
        }
    }
}

/* !
 * @brief ûɻص
 *
 * @note 䵽ebyte_callback.hм
 */
void UserReceiveDoneCallback( uint8_t* buffer, uint16_t length )
{
    uint8_t  j,  pcEchoLength;
    uint8_t* p;
    /* ͨжǷping pongָ  */
    if( length == 4 || length == 5 )
    {
        p = buffer;
        for( j = 0; j < 4; j++ )
        {
            if( BufferPing[j] != *p++ )
            {
                break;
            }
        }
        //Ƚϵĩβʾȫƥping
        if( j == 4 )
        {
            Callback_isPingCheckReady = 1;//֪ͨظPong
            if( length == 5 && PC_isConnected )
            {
                BufferPong[4] = buffer[4];//5ֽΪʶ
            }
        }
        if( j != 4 && length == 5 && PC_isConnected )
        {
            p = buffer;
            for( j = 0; j < 4; j++ )
            {
                if( BufferPong[j] != *p++ )
                {
                    break;
                }
            }
            if( j == 4 )//ȫƥpong
            {
                if( 0x01 == buffer[4] )
                {
                    Ebyte_DEBUG_CommandEcho( ( uint8_t* )SimulatedCommandsWireless1, EBYTE_CMD_PACKAGE_LENGTH, PcEchoBuffer, &pcEchoLength );
                }
                else
                {
                    Ebyte_DEBUG_CommandEcho( ( uint8_t* )SimulatedCommandsWireless2, EBYTE_CMD_PACKAGE_LENGTH, PcEchoBuffer, &pcEchoLength );
                }
                Ebyte_BSP_UartTransmit( PcEchoBuffer, pcEchoLength );
            }
        }
    }
    Ebyte_BSP_LedControl( BSP_LED_1, ON );
    if( ! PC_isConnected )
    {
        DEBUG( "\r\n #RECV: " );
        Ebyte_BSP_UartTransmit( buffer, length );
    }
    Ebyte_BSP_LedControl( BSP_LED_1, OFF );
    /* 
       ע⣺ģô˻صʱѾ˽״̬ҪգҪٴν״̬ */
    //Ebyte_RF.EnterReceiveMode();
}