#include "hw3000.h"
#include "board.h"
#include "ebyte_conf.h"
#define delay1ms Ebyte_Port_DelayMs
Hw3000Param_t       Hw3000Param;                    //HW3000 Խṹ
volatile uint8_t    Hw3000_irq_request;	            //request for irq
Hw3000Data_t        Hw3000_data_buf;
#define EBYTE_E42_PROGRAM_TYPE 0x10 
#if defined(EBYTE_E42_400M20S)
static uint8e_t E42x_NameString[] = "E42-400M20S";
#elif defined(EBYTE_E42_900M20S)
static uint8e_t E42x_NameString[] = "E42-900M20S";
#endif 
/*----HW3000 SPIIO ʼ ----*/
void Hw3000_GPIO_Init( void )
{
    //PDN 
  
    //IRQ 
 
   //GPIOж

     //½ж

}

/*----GPIO ⲿжϳ----*/
void PORT2_IRQHandler(void)
{

}

/*****************************************************
@function:  HW3000һĴд
@param:     addr : Ĵַ
@param:     data : Ҫд
@return:    
*****************************************************/
void Hw3000_Write_Reg( uint8_t addr, uint16_t halfWord )
{
    addr |= 0X80;                               //дʹ
    Ebyte_Port_SpiCsIoControl( 0 );                            //SPIƬѡ
    
    Ebyte_Port_SpiTransmitAndReceivce( addr );                //дĴַ
            
    Ebyte_Port_SpiTransmitAndReceivce( halfWord >> 8 );       //д8λ
    
    Ebyte_Port_SpiTransmitAndReceivce( (uint8_t) halfWord );  //д8λ
    
    Ebyte_Port_SpiCsIoControl( 1 );                           //SPIƬѡ
}

/*****************************************************
@function:  ȡHW3000һĴ
@param:     addr : Ĵַ
@return:    ȡһĴ
*****************************************************/
uint16_t Hw3000_Read_Reg( uint8_t addr )
{
    uint16_t temp = 0;
    
    addr=addr&0x7F;                             //ʹ
    
    Ebyte_Port_SpiCsIoControl( 0 );                             //SPIƬѡ
    
    Ebyte_Port_SpiTransmitAndReceivce( addr );                //дĴַ
            
    temp = Ebyte_Port_SpiTransmitAndReceivce( 0XFF );
    
    temp <<= 8;
    
    temp |= Ebyte_Port_SpiTransmitAndReceivce( 0XFF );  
    
    Ebyte_Port_SpiCsIoControl( 1 );                           //SPIƬѡ
    
    return temp;
}

/*****************************************************
@function:  д
@param:     *WriteBuff : дݵָ
@param:     length : дݵĸ
@return:    
*****************************************************/
void Hw3000_Write_Buff(uint8_t addr, uint8_t *WriteBuff, uint16_t length)
{
    if( length > HW3000_BUF_LEN)
        return;
        
    addr |= 0X80;                               //дʹ
    Ebyte_Port_SpiCsIoControl( 0 );                            //SPIƬѡ
    
    Ebyte_Port_SpiTransmitAndReceivce( addr );                //дĴַ
            
    while( length-- )
        Ebyte_Port_SpiTransmitAndReceivce( *WriteBuff++ );       //д8λ
    
    Ebyte_Port_SpiCsIoControl( 1 );                          //SPIƬѡ

}

/*****************************************************
@function:  
@param:     **ReadBuff : Ŷݵָ
@param:     length : ݵĸ
@return:    
*****************************************************/
void Hw3000_Read_Buff(uint8_t addr, uint8_t *ReadBuff, uint16_t length)
{
    if( length > HW3000_BUF_LEN)
        return;
    addr=addr&0x7F;                             //ʹ
    
    Ebyte_Port_SpiCsIoControl( 0 );                            //SPIƬѡ
    
    Ebyte_Port_SpiTransmitAndReceivce( addr );                //дĴַ
            
    while( length-- )
        *ReadBuff++ = Ebyte_Port_SpiTransmitAndReceivce( 0XFF );
    
    Ebyte_Port_SpiCsIoControl( 1 );                           //SPIƬѡ
}

/*****************************************************
@function:  Ƶ
@param:     osc_fe Ƶö
@return:    
*****************************************************/
void Hw3000_Osc_Set( OscFreq_e osc_fe )
{
	if ( osc_fe == OSC20MHZ ) 
		Hw3000_Write_Reg(MODEMCTRL, 0x5201);            //20MHz osc select
    else            
	 	Hw3000_Write_Reg(MODEMCTRL, 0x1201);            //26MHz osc select	
}
/*****************************************************
@function:  HW3000 SPIͨǷOK
@param:     
@return:    1SPIͨ
            0SPIͨʧ
*****************************************************/  
uint8_t Hw3000_Check_Spi( void )
{
    Hw3000_Osc_Set( OSC26MHZ );                       //д         
    
    if( Hw3000_Read_Reg( MODEMCTRL ) == 0X1201 )      //        
        return 1;
    else
        return 0;    
}

/*****************************************************
@function:  HW3000λ-Reset0
            λӲ·FIFO
            Ĵֲֵ
@param:     
@return:    
*****************************************************/
void Hw3000_Soft_Reset0( void )
{
    Hw3000_Write_Reg( SFTRST0, 0X55AA);
}

/*****************************************************
@function:  HW3000λ-Reset1
            ȫоƬλĴֵָĬֵ
@param:     
@return:    
*****************************************************/ 
void Hw3000_Soft_Reset1( void )
{
    Hw3000_Write_Reg( SFTRST1, 0X55AA);
}

/*****************************************************
@function:  ȡжϱ־λ
@param:     
@return:    жϱ־
*****************************************************/
uint16_t Hw3000_Read_IntFlag( void )
{
    return  Hw3000_Read_Reg( INTFLAG );    
}

/*****************************************************
@function:  жϱ־λ
@param:     
@return:    
*****************************************************/
void  Hw3000_Clear_IntFlag( uint16_t IntFlag )
{
    Hw3000_Write_Reg(INTIC, IntFlag);
}

/*****************************************************
@function:  ȡоƬ״ָ̬ʾĴ0
@param:     
@return:    оƬ״̬
*****************************************************/
uint16_t Hw3000_Read_ChipSta0( void )
{
    return  Hw3000_Read_Reg( CHIPSTA0 );    
}

/*********************************************************************************************
@function:  HW3000״̬л
@param:     WorkState:״̬
@return:    
@remark:    
1.ڹģʽ֮лʱһģʽ,ܿһģʽ
2.SLEEP(RC)DEEP SLEEP״̬SPIɷʼĴɷFIFOжϱ־λ塯0
3.оƬDEEP SLEEP/SLEEPָIDLE״̬üĴ⣬мĴλע⣬Ĵе״ָ̬ʾλλ
*********************************************************************************************/ 
void Hw3000_State_Set( WorkMode_e Work_Mode )    
{
    uint16_t time = 0XFFF;
    
    switch( Work_Mode )
    {
        case PowerDownEnable:         //
                GPIO_WriteBit( BSP_GPIO_PORT_E42_SDN , BSP_GPIO_PIN_E42_SDN , SET);                            //оƬ Power Down ״̬
                Hw3000Param.ChipState = POWER_DOWN;             
                break;              
        case PowerDownDisable:           //ӵ״̬лIDLE״̬  
                GPIO_WriteBit( BSP_GPIO_PORT_E42_SDN , BSP_GPIO_PIN_E42_SDN , RESET) ;                           //оƬPower Down״ָ̬IDLE״̬                
                while( ( !( Hw3000_Read_IntFlag() & INT_CHIPRDY ) )&& time )            //wait for chip ready
                    time--;       
                Hw3000_Clear_IntFlag( INT_PORINT | INT_CHIPRDY );                       //POR ,Readyж
                Hw3000Param.ChipState = IDLE;                                            //оƬȫλ                  
                break;              
        case DeepSleepEnable:   //
                Hw3000_Write_Reg( TRCTRL, RF_TX_RX_DISABLE );                           //ʧܽպͷ
                Hw3000_Write_Reg( WDTCFG1, 0x0001);                                     //ʧWDT
                Hw3000_Write_Reg( MODECTRL, Hw3000_Read_Reg( MODECTRL ) | 0X8000);      //SLEEP_ON
                break;
        case DeepSleepDisable:      //лIDLE      -------ҪƵ
                Hw3000_Write_Reg( WDTCFG1, 0x0081);                                     //ʹWDT
                Hw3000_Write_Reg( MODECTRL, Hw3000_Read_Reg( MODECTRL ) & 0x7FFF);      //SLEEP_OFF
                while( (!( Hw3000_Read_IntFlag() & INT_CHIPRDY )) && time)              //wait for chip ready
                    time--;
                Hw3000_Clear_IntFlag( INT_CHIPRDY );
                Hw3000_BaseFreq_Set( Hw3000Param.TransmitParam.BaseFreq );              //from deep sleep/sleep need reconfigure this reg                
                Hw3000Param.ChipState = IDLE;                                           //üĴ⣬мĴλ
                break;        
        case SleppEnable:        //˯ģʽ
                Hw3000_Write_Reg( TRCTRL, RF_TX_RX_DISABLE );                           //ʧܽպͷ
                Hw3000_Write_Reg( WDTCFG1, 0x0081);                                     //ʹWDT
                Hw3000_Write_Reg( MODECTRL, Hw3000_Read_Reg( MODECTRL ) | 0X8000);      //SLEEP_ON
                break;  
        case SleepDisable:          //˯ģʽлIDLE     -----ҪƵ
                Hw3000_Write_Reg( TRCTRL, RF_TX_RX_DISABLE );                           //ʧܽպͷ
                Hw3000_Write_Reg(WDTCFG1, 0x0081);
                Hw3000_Write_Reg( MODECTRL, Hw3000_Read_Reg( MODECTRL ) & 0x7FFF);      //SLEEP_OFF
                while( (!( Hw3000_Read_IntFlag() & INT_CHIPRDY ) )&& time)              //wait for chip ready
                    time--;
                Hw3000_Clear_IntFlag( INT_CHIPRDY );
                Hw3000_BaseFreq_Set( Hw3000Param.TransmitParam.BaseFreq );              //from deep sleep/sleep need reconfigure this reg   
                Hw3000Param.ChipState = IDLE;        
                break;
        case TXEnable:           //ʹ            
                if( Hw3000Param.ChipState != RX )                                       //ҪоƬ״̬лΪIDLEл
                {
                    Hw3000_Write_Reg( TRCTRL, RF_TX_ENABLE );
                    Hw3000_Write_Reg( FIFOSTA, CLK_WR_PTR );                            //flush fifo дָ
                    Hw3000Param.ChipState = TX;
                }
                break;
        case TXDisable:        //ʧ
                Hw3000_Write_Reg( TRCTRL, RF_TX_ENABLE );        
                Hw3000Param.ChipState = IDLE;
                while( ( !( Hw3000_Read_ChipSta0() & FSM_IDLE )  ) && time )
                    time--;
                break;        
        case RXEnable:         //ʹ             
                if( Hw3000Param.ChipState != TX )
                {
                    Hw3000_Write_Reg( TRCTRL, RF_RX_ENABLE );
                    Hw3000_Write_Reg( FIFOSTA, CLR_RD_PTR );                           //flush fifo ָ
                    Hw3000Param.ChipState = RX;                    
                    Hw3000_irq_request = 0;                    
                }
                break;
        case RXDisable:        //ʧ
                Hw3000_Write_Reg( TRCTRL, RF_TX_RX_DISABLE );
                Hw3000_Clear_IntFlag( FIFO0_INT );
                Hw3000Param.ChipState = IDLE;
                Hw3000_irq_request = 0;
                while( (!( Hw3000_Read_ChipSta0() & FSM_IDLE ) ) && time )
                    time--;
                break;
    }
}

void E42x_GoReceive(void)
{
  Hw3000_State_Set(RXEnable);
}


/*!
 * @brief ȡģ
 * 
 * @return ַָָ 
 * @note ׼ַ ĩβн '\0'
 */
uint8e_t* E42x_GetName(void)
{
    return E42x_NameString;
}

uint8e_t E42x_GetDriverVersion(void)
{
  return  EBYTE_E42_PROGRAM_TYPE;
}

uint8_t E42x_TaskForPoll(void)
{
  volatile int ret=0;
  if( Hw3000Param.RFState == RX_INIT )    //лģʽ
  {
    Hw3000_State_Set( RXEnable);
    Hw3000Param.RFState = RX_RUN;
  }

  if( Hw3000Param.RFState == RX_RUN )
  {
    if( Hw3000_irq_request==1)       //IRQŲ½жϣжϴиı־1
    {
      Hw3000_irq_request =0;
      
      if ( Hw3000_rx_data( Hw3000Param , &Hw3000_data_buf) == 0)     //յȷ   
      {
        ret=1;		
      }
      else
      {
        Hw3000Param.RFState=RX_INIT;
        Hw3000_State_Set(RXDisable);
        ret =0;
      }
    }
  }
  if(ret){
    
    if(Hw3000_data_buf.len >255)
    {
      Hw3000_data_buf.len=255;
      Hw3000_State_Set(RXDisable);
      Hw3000_State_Set( RXEnable);
    }
    Ebyte_Port_ReceiveCallback(Hw3000_data_buf.data ,Hw3000_data_buf.len);

  }
  return ret;
}

/*****************************************************
@function:  Bank1 Ĵб ʹ ʧ
@param:     enable ʹ/ʧ
@return:    
*****************************************************/
void Hw3000_Bank1_En( uint8_t enable )
{
	if ( ENABLE == enable ) 
		Hw3000_Write_Reg( 0X4C, 0x55AA);        //ɲBANK1ļĴб
    else 
	 	Hw3000_Write_Reg( 0X4C, 0X5555);        //ɲBANK0ļĴб	    
}

/*****************************************************
@function:  BANK1 Ĵб޸
@param:     
@return:    
*****************************************************/
void Hw3000_Bank1_Set( void )
{
    uint8_t i;
    uint16_t agc_table[16] = {0x1371,0x1351,0x0B51,0x2F71,0x2F51,0x2E51,
							  0x2E31,0x4B31,0x4731,0x4631,0x4531,0x4431,
							  0x6131,0x6031,0x6011,0x6009};
    //ԺſԲBANK1
    Hw3000_Bank1_En( ENABLE );          
                      
    for (i = 0; i < 16; i++)
        Hw3000_Write_Reg( 0x1B + i, agc_table[i]);	
    
    Hw3000_Write_Reg(0x03, 0x0508);
    Hw3000_Write_Reg(0x11, 0xC630); 
                                                         
    if( Hw3000Param.TransmitParam.Rate < 10)
    {
        Hw3000_Write_Reg(0x14, 0x1935);		
        Hw3000_Write_Reg(0x40, 0x0008);
        Hw3000_Write_Reg(0x41, 0x0010);
        Hw3000_Write_Reg(0x42, 0x82D8);
        Hw3000_Write_Reg(0x43, 0x3D38);  
    }
    else if( Hw3000Param.TransmitParam.Rate <19.2)
    {            
        Hw3000_Write_Reg(0x14, 0x1935);	
        Hw3000_Write_Reg(0x40, 0x0008);
        Hw3000_Write_Reg(0x41, 0x0010);
        Hw3000_Write_Reg(0x42, 0x82D8);
        Hw3000_Write_Reg(0x43, 0x3D38);
    }
    else
        Hw3000_Write_Reg(0x14, 0x1915);
        
	if( Hw3000Param.ChipParam.Oscfreq == OSC20MHZ )
    {

        switch ( Hw3000Param.ChipParam.FreqLev ) 
        { 
            case OSC20M_FREQ_285_350MHZ:        //315
            case OSC26M_FREQ_285_348MHZ:
                                        Hw3000_Write_Reg(0x17, 0xF223); 
                                        break;
            case OSC20M_FREQ_428_522MHZ:        //433
            case OSC26M_FREQ_428_522MHZ:
            case OSC26M_FREQ_403_437MHZ:
                                        Hw3000_Write_Reg(0x17, 0xF6C2);
                                        break;
            case OSC20M_FREQ_700_874MHZ:        //779
                                        Hw3000_Write_Reg(0x17, 0xFB61);
                                        break;
            case OSC26M_FREQ_806_874MHZ:        //868
                                        Hw3000_Write_Reg(0x17, 0xFB61);
                                        break;
            case OSC20M_FREQ_856_1045MHZ:       //915M
            case OSC26M_FREQ_856_1045MHZ:
                                        Hw3000_Write_Reg(0x17, 0xFB61);
                                        break;
            default:
                break;
        }  

    }
    
    if( Hw3000Param.ChipParam.Oscfreq == OSC26MHZ )
    {
        switch ( Hw3000Param.ChipParam.FreqLev ) 
        { 
            case OSC20M_FREQ_285_350MHZ:        //315
            case OSC26M_FREQ_285_348MHZ:
                                        Hw3000_Write_Reg(0x17, 0xF556); 
                                        break;
            case OSC20M_FREQ_428_522MHZ:        //433
            case OSC26M_FREQ_428_522MHZ:
            case OSC26M_FREQ_403_437MHZ:
                                        Hw3000_Write_Reg(0x17, 0xF8E3);
                                        break;
            case OSC20M_FREQ_700_874MHZ:        //779
                                        Hw3000_Write_Reg(0x17, 0xF8E3);
                                        break;
            case OSC26M_FREQ_806_874MHZ:        //868
                                        Hw3000_Write_Reg(0x17, 0xFC72);
                                        break;
            case OSC20M_FREQ_856_1045MHZ:       //915M
            case OSC26M_FREQ_856_1045MHZ:
                                        Hw3000_Write_Reg(0x17, 0xFC72);
                                        break;
            default:
                break;
        } 
    }
    
    Hw3000_Write_Reg(0x51, 0x001B);
    Hw3000_Write_Reg(0x55, 0x8003);
    Hw3000_Write_Reg(0x56, 0x4155);
    Hw3000_Write_Reg(0x62, 0x70ED); 
    
    //رBANK1ʹ
    Hw3000_Bank1_En( DISABLE);          
    Hw3000_Clear_IntFlag( INT_PORINT );
}


/*****************************************************
@function:  ͹
@param:     Power;ʵȼ 
@return:    
*****************************************************/
void Hw3000_TxPower_Set( int8_t Power)
{
	switch ( Power )
    {
		case -40:
			Hw3000_Write_Reg(PACFG, 0x003F);         
			break;
		case -16:
			Hw3000_Write_Reg(PACFG, 0x013F); 
			break;
		case -10:
			Hw3000_Write_Reg(PACFG, 0x023F); 
			break;
		case -5:
			Hw3000_Write_Reg(PACFG, 0x043F); 
			break;
		case 0:
			Hw3000_Write_Reg(PACFG, 0x073F); 
			break;
		case 5:
			Hw3000_Write_Reg(PACFG, 0x0C3F); 
			break;
		case 10:
			Hw3000_Write_Reg(PACFG, 0x183F); 
			break;
		case 15:
			Hw3000_Write_Reg(PACFG, 0x2A3F); 
			break;
		case 18:
			Hw3000_Write_Reg(PACFG, 0x643F); 
			break;
		case 20:
			Hw3000_Write_Reg(PACFG, 0xFF3F); 
			break;
		default:
			break;
	}   
}

/*****************************************************
@function:  ֡ṹ
@param:     frame_mode ֡ṹ ǿ or FIFO
@return:    
*****************************************************/
void Hw3000_Frame_Set( FrameMode_e frame_mode)
{
    //frame mode
    if( frame_mode == FRAME )       
    {
        Hw3000_Write_Reg(PKTCTRL, 0xC000);
		Hw3000_Write_Reg(PKTCFG0, 0x8010);          //SFD 4bytes, preamble 8 bytes
		Hw3000_Write_Reg(PREACFG, 0x0206);
		if (Hw3000Param.ChipParam.Ack_mode == ENABLE)
        {
			Hw3000_Write_Reg(ACKCFG, 0x30FF);	    //re tx times and re ack time
			Hw3000_Write_Reg(PIPECTRL, 0x0011);     //PIPE 0 enable 
		} 
        else 
        {
			Hw3000_Write_Reg(PIPECTRL, 0x0001);     //PIPE 0 enable
		}
    }
    //direct fifo mode
    else    
    {
		Hw3000_Write_Reg( PKTCTRL, 0x4000);
		Hw3000_Write_Reg( PKTCFG0, 0x8010);         //ָ֡SFD 4bytes, preamble 16 bytes
		Hw3000_Write_Reg( PREACFG, 0x0206); 
		Hw3000_Write_Reg( FIFOSTA, 0x0000);         //first 2 bytes is length
		Hw3000_Write_Reg( LEN0RXADD,0x0000);        //no add bytes
		Hw3000_Write_Reg( PIPECTRL, 0x0001);        //PIPE 0 enable    
    }
}

/*****************************************************
@function:  
@param:     fRate ʣλKbps,Χ[1.2K,100K]
            SYMBOL_RATE = round(( bps *2^22) /(2*10^6))
                        = round( ( bps * 4194304 ) / 2000000 )
@return:    
*****************************************************/
void Hw3000_Rate_Set( float fRate)
{
    uint32_t Symbol_rate;
    
    Symbol_rate = ( fRate * 4194304 / 2000 )+ 0.5;                              //
    
    Hw3000_Write_Reg( SYMRATE0, (uint16_t ) ( Symbol_rate >> 8 ) );             //32 Rate[bit17,bit8]
    Hw3000_Write_Reg( SYMRATE1, ( uint16_t) ( Symbol_rate & 0X00FF) );          //33 Rate[bit7,bit0]
    
    if( Hw3000Param.ChipParam.Oscfreq == OSC20MHZ )
    {
        if( fRate <= 1 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0002);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0007);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0007); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0002); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 10 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0025);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007B);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0029); 
                    break;
                default:
                    break;
			}
        } 
        else if( fRate <= 10 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0025);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007B);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0029); 
                    break;
                default:
                    break;
			}
        }  
        else if( fRate <= 19.2 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x002A);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007B);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0029); 
                    break;
                default:
                    break;
			}
        }   
        else if( fRate <= 38.4 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0033);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007B);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0029); 
                    break;
                default:
                    break;
			}
        } 
        else if( fRate <= 50 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0037);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007B);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0029); 
                    break;
                default:
                    break;
			}
        }       
        else if( fRate <= 100 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0078);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC20M_FREQ_285_350MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x00F6);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC20M_FREQ_350_437MHZ:
                case OSC20M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x00A4); 
                    break;
                case OSC20M_FREQ_700_874MHZ:
                case OSC20M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0052); 
                    break;
                default:
                    break;
			}
        } 
    }
    else if( Hw3000Param.ChipParam.Oscfreq == OSC26MHZ )
    {
        //ý˲Ĵ͵Ƶƫ
        if( fRate <= 1 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0002);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0006);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0004); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0002); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0002); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 10 )
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0025);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x005F);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 19.2)
        {
            Hw3000_Write_Reg(FILTERBAND, 0x002A);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x005F);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 38.4)
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0033);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x005F);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 50)
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0037);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x005F);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x0020); 
                    break;
                default:
                    break;
			}
        }
        else if( fRate <= 100)
        {
            Hw3000_Write_Reg(FILTERBAND, 0x0078);           //2E-˲ BW = (FILTER2_BAND+1)*1kHz        --3K
            //͵
			switch (Hw3000Param.ChipParam.FreqLev) 
            {
                case OSC26M_FREQ_285_348MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x00BD);    //2C-ƵƵƫ DEVIATION = round(fdev*kdev/ fxtal) 
                    break;
                case OSC26M_FREQ_403_437MHZ:
                case OSC26M_FREQ_428_522MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x007E); 
                    break;
                case OSC26M_FREQ_806_874MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                case OSC26M_FREQ_856_1045MHZ:
                    Hw3000_Write_Reg(DEVIATION, 0x003F); 
                    break;
                default:
                    break;
			}
        }        
    }
}


/*****************************************************
@function:  ʼƵ
@param:     baseFreq : Ƶ-MHZ
@return:    
*****************************************************/
void Hw3000_BaseFreq_Set( uint16_t baseFreq )
{
    uint8_t Kfreq, Osc;    
    uint16_t rfcfg, freqcfg0;
    uint16_t freq_int;              //Ƶ
    uint32_t freq_dec_f;
    float freq_dec;                 //С    
    
    rfcfg = Hw3000_Read_Reg( RFCFG ) & ( ~( PLL_TRXLB_SEL_11 | VCO_HB_SEL_1 ) );    //Ƶ㷶Χ
    
    freqcfg0 = Hw3000_Read_Reg( FREQCFG0 ) & ( ~RF_FREQ_BASE_MSK );                 //Ƶ
            
    if( Hw3000Param.ChipParam.FreqSetMode == DEFAULT )                              //ֻ֧433MƵ
    {           
		freqcfg0 |= baseFreq *10;                                                   //λ 100KHZ
        switch( Hw3000Param.ChipParam.FreqLev )
        {
            case OSC20M_FREQ_350_437MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_0 );
                    break;
            case OSC20M_FREQ_428_522MHZ:
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_1 );
                    break;
            case OSC26M_FREQ_403_437MHZ:                
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_0 );
                    break;
            case OSC26M_FREQ_428_522MHZ:
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_1 );           
                    break;
        }    
        Hw3000_Write_Reg( RFCFG, rfcfg );                                           //Ƶ㷶Χ                                            
        Hw3000_Write_Reg( FREQCFG0, freqcfg0 );                                     //ʼƵʵ       
    }
    else
    {
		switch( Hw3000Param.ChipParam.FreqLev )
        {
            case OSC20M_FREQ_235_291MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_10 | VCO_HB_SEL_0 );                       //Kfreq = 6
                    Kfreq = 6;  Osc = 20;   
                    break;          
            case OSC20M_FREQ_285_350MHZ:            
                    //Ƶ㷶Χ                    
                    rfcfg |= ( PLL_TRXLB_SEL_10 | VCO_HB_SEL_1 );                       //Kfreq = 6
                    Kfreq = 6;  Osc = 20;               
                    break;
            case OSC20M_FREQ_350_437MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_0 );                       //Kfreq = 4
                    Kfreq = 4;  Osc = 20;             
                    break;              
            case OSC20M_FREQ_428_522MHZ:                
                    //Ƶ㷶Χ                             
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_1 );                       //Kfreq = 4
                    Kfreq = 4;  Osc = 20;                                  
                    break;              
            case OSC20M_FREQ_700_874MHZ:                
                    //Ƶ㷶Χ                             
                    rfcfg |= ( PLL_TRXLB_SEL_00 | VCO_HB_SEL_0 );                       //Kfreq = 2
                    Kfreq = 2;  Osc = 20;                                    
                    break;              
            case OSC20M_FREQ_856_1045MHZ:               
                    //Ƶ㷶Χ                             
                    rfcfg |= ( PLL_TRXLB_SEL_00 | VCO_HB_SEL_1 );                       //Kfreq = 2
                    Kfreq = 2;  Osc = 20;           
                    break;
            case OSC26M_FREQ_270_291MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_10 | VCO_HB_SEL_0 );                       //Kfreq = 6
                    Kfreq = 6;  Osc = 26;                       
                    break;          
            case OSC26M_FREQ_285_348MHZ:            
                    //Ƶ㷶Χ                    
                    rfcfg |= ( PLL_TRXLB_SEL_10 | VCO_HB_SEL_1 );                       //Kfreq = 6
                    Kfreq = 6;  Osc = 26;  
            case OSC26M_FREQ_403_437MHZ:                
                    //Ƶ㷶Χ                          
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_0 );                       //Kfreq = 4
                    Kfreq = 4;  Osc = 26;  
                    break;  
            case OSC26M_FREQ_428_522MHZ:    
                    //Ƶ㷶Χ      
                    rfcfg |= ( PLL_TRXLB_SEL_01 | VCO_HB_SEL_1 );                       //Kfreq = 4
                    Kfreq = 4;  Osc = 26;         
                    break;
            case OSC26M_FREQ_806_874MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_00 | VCO_HB_SEL_0 );                       //Kfreq = 2
                    Kfreq = 2;  Osc = 26;  
                    break;
            case OSC26M_FREQ_856_1045MHZ:
                    //Ƶ㷶Χ
                    rfcfg |= ( PLL_TRXLB_SEL_00 | VCO_HB_SEL_1 );                       //Kfreq = 2            
                    Kfreq = 2;  Osc = 26;            
                    break;    
        }   
        //Ƶ㷶Χ   
        Hw3000_Write_Reg( RFCFG, rfcfg );   
        //ʼƵ
        freq_int = baseFreq * Kfreq / Osc; 
        freq_dec = baseFreq * Kfreq / ( Osc * 1.0) - freq_int;              //С
        freq_dec_f = freq_dec * 2097152;             
        Hw3000_Write_Reg( FREQCFG1, (freq_dec_f >> 16 ) | RF_PLL_DIRECT );  //С             
        Hw3000_Write_Reg( FREQCFG2, freq_dec_f );  
        freqcfg0 |= freq_int;
        Hw3000_Write_Reg( FREQCFG0, freqcfg0 );                             //          
    }

}

/*****************************************************
@function:  ŵ,ͬʱŵô(BW)
@param:     ch_space ŵö
@return:    
*****************************************************/
void Hw3000_ChSpace_Set( ChSpace_e ch_space )
{
    uint16_t  freqcfg0, rfcfg;
    
    rfcfg = Hw3000_Read_Reg( RFCFG ) & ( ~PLL_LPFR_MSK );               //PLL·
    freqcfg0 = Hw3000_Read_Reg( FREQCFG0 ) & ( ~CH_SPACE_MSK );         //ŵ
    
    switch( ch_space )
    {
        case CH_SPACE_100K: 
                        rfcfg |= BW50K << PLL_LPFR_BIT;                 //BW = 50K
                        freqcfg0 |= CH_SPACE_100K << CH_SPACE_BIT;      //ŵΪ100K
                        break;
        case CH_SPACE_200K:
                        rfcfg |= BW75K << PLL_LPFR_BIT;
                        freqcfg0 |= CH_SPACE_200K << CH_SPACE_BIT;
                        break;
        case CH_SPACE_400K:
                        rfcfg |= BW100K << PLL_LPFR_BIT;
                        freqcfg0 |= CH_SPACE_400K << CH_SPACE_BIT;
                        break;
        case CH_SPACE_800K:
                        rfcfg |= BW150K << PLL_LPFR_BIT;
                        freqcfg0 |= CH_SPACE_800K << CH_SPACE_BIT;
                        break;
    }    
    Hw3000_Write_Reg( RFCFG, rfcfg );
    Hw3000_Write_Reg( FREQCFG0, freqcfg0 );
}

/*****************************************************
@function:  ŵ ֻе  ƵģʽΪ Ĭģʽʱʺϵ
            ŵƵ = ʼƵ(Khz) + ( ŵ * 2^ŵ * 100KHZ )
                         = RF_FREQ_BASE + ( CHANNEL1*2^CH_SPACE*100kHz)
             = 428000 + ( 1 * 8 * 100 ) = 428800 KHz    //ʼƵ428Mŵ1ŵ800K 
@param:     channel:ŵ 0 - 255
@return:    
*****************************************************/
void Hw3000_Channel_Set( uint8_t channel )
{
    Hw3000_Write_Reg( CHCFG0, (uint16_t)channel << 8 );
}


/*****************************************************
@function:  ǰ
@param:     PreambleParamǰԣͣȣ
@return:    
*****************************************************/
void Hw3000_Preamble_Set( Preamble_t PreambleParam )    
{
    uint16_t Temp;
    
    Temp = Hw3000_Read_Reg( PKTCFG0 );
    if( PreambleParam.Len < 4 )
        PreambleParam.Len = 4;
        
    if( PreambleParam.Type == 0X55)
        Hw3000_Write_Reg( PKTCFG0, (Temp & 0XEFFF )| PreambleParam.Len );
    else
        Hw3000_Write_Reg( PKTCFG0, Temp | 0X1000 | PreambleParam.Len );
}

/*****************************************************
@function:  tx 0101
@param:     
@return:    
*****************************************************/
void Hw3000_tx_0101(void)
{
	Hw3000_Write_Reg(MODECTRL, 0x190F);     //DERECT_MOD REP_MOD   
	Hw3000_Write_Reg(TRCTRL, 0x0100);       //tx_enable
	delay1ms(1);
	Hw3000_Write_Reg(MODECTRL, 0x1B0F);	
}

/*****************************************************
@function:  cancel tx 0101
@param:     
@return:    
*****************************************************/
void Hw3000_cancel_0101(void)
{
	Hw3000_Write_Reg(TRCTRL, 0x0000);           //tx_disable    
	Hw3000_Write_Reg(MODECTRL, 0x100F);	
}

/*****************************************************
@function:  tx pn9
@param:     
@return:    
*****************************************************/
void Hw3000_tx_pn9(void)
{
	Hw3000_Write_Reg(MODECTRL, 0x150F);     //DERECT_MOD REP_MOD    
	Hw3000_Write_Reg(TRCTRL, 0x0100);       //tx_enable
	delay1ms(1);
	Hw3000_Write_Reg(MODECTRL, 0x170F);	
}

/*****************************************************
@function:  cancel tx pn9
@param:     
@return:    
*****************************************************/
void Hw3000_cancel_pn9(void)
{
	Hw3000_Write_Reg(TRCTRL, 0x0000);           //tx_disable   cancel tx pn9
	Hw3000_Write_Reg(MODECTRL, 0x100F);	
}

/*****************************************************
@function:  tx single carrier-ز
@param:     
@return:    
*****************************************************/ 
void Hw3000_tx_sw(void)
{
	Hw3000_Write_Reg(PKTCTRL, 0xE000);      //enable single carrior mode     tx single carrier
	Hw3000_Write_Reg(DEVIATION, 0x0000);    //divation 0 Hz
	Hw3000_Write_Reg(TRCTRL, 0x0100);       //tx enable
	Hw3000_Write_Reg(FIFODATA, 0x5555);
	Hw3000_Write_Reg(FIFOCTRL, 0x0001);     //ocpy = 1
}

/*****************************************************
@function:  cancel single carrier رز
@param:     
@return:    
*****************************************************/ 
void Hw3000_cancel_sw(Hw3000Param_t hw3000_param)    
{	
	uint16_t reg_val;
	
	Hw3000_Write_Reg(FIFOCTRL, 0x0000); //ocpy = 0    cancel single carrier
	Hw3000_Write_Reg(TRCTRL, 0x0000); //tx disable
	
	if ( hw3000_param.ChipParam.FrameMode == FRAME ) 
    {	 //ǿ֡ṹ 
		Hw3000_Write_Reg(PKTCTRL, 0xC000);
	} 
    else 
    {
		if (hw3000_param.ChipParam.tx_mode == 0) {
			reg_val = 0x0000;
		} else {
			reg_val = 0x4000;
		}
		if (hw3000_param.ChipParam.rx_mode == 1) {
			reg_val |=  0x0100;
		} 	
		Hw3000_Write_Reg(PKTCTRL, reg_val);
	}
	
	Hw3000_Rate_Set( hw3000_param.TransmitParam.Rate );
}

/*****************************************************
@function:  HW3000 ʼ
@param:     
@return:    
*****************************************************/                                              
void Hw3000_Init( void  )
{
   // Hw3000_GPIO_Init();
    
    Hw3000Param.ChipParam.Oscfreq = OSC26MHZ;                       //26M
    Hw3000Param.ChipParam.FreqLev = OSC26M_FREQ_428_522MHZ;         //433MƵ    
    Hw3000Param.ChipParam.FreqSetMode = DIRECT;                     //ƵģʽΪֱģʽ
    Hw3000Param.ChipParam.FrameMode = FRAME;                        //֡ṹ    
    Hw3000Param.ChipParam.Ack_mode = DISABLE;                       //Ӧ
    Hw3000Param.ChipParam.ChSpace = CHAN_SPACE;                     //ŵ 

    Hw3000Param.TransmitParam.BaseFreq = BASE_FREQ;                 //Ƶ
    Hw3000Param.TransmitParam.TxPower = 20,                         //书
    Hw3000Param.TransmitParam.PreambleParam.Type = 0XAA;            //ǰͣ0X55,0XAA
    Hw3000Param.TransmitParam.PreambleParam.Len = 10;               //ǰ볤
    Hw3000Param.TransmitParam.Rate = 10;                            //10K      
  
    Hw3000_State_Set( PowerDownEnable );    
    delay1ms(1);
    Hw3000_State_Set( PowerDownDisable );
                            
	Hw3000_Bank1_Set();                                             //BANK1 ʼ
                    
	Hw3000_Write_Reg(MIXFW, 0x2E35);	                            //must modify this value--yes	
	Hw3000_Write_Reg(MODECTRL, 0x100F);	                            //must close GPIO clock for noise reason--yes 
                
    Hw3000_Osc_Set( Hw3000Param.ChipParam.Oscfreq );                //þƵ
	
    Hw3000_BaseFreq_Set( Hw3000Param.TransmitParam.BaseFreq );      //ûƵ--from deep sleep/sleep need reconfigure this reg
    
    Hw3000_ChSpace_Set( Hw3000Param.ChipParam.ChSpace );            //ŵ
	
	Hw3000_Rate_Set( Hw3000Param.TransmitParam.Rate );              //
    
    Hw3000_TxPower_Set( Hw3000Param.TransmitParam.TxPower );        //÷书
    
    Hw3000_Frame_Set( Hw3000Param.ChipParam.FrameMode );            //֡ṹ

    Hw3000_Write_Reg(0x14, 0x7e7e);                                 //set SFD First word
    Hw3000_Write_Reg(0x15, 0x7e7e);                                 //set SFD Second word

    GPIO_WriteBit( BSP_GPIO_PORT_E42_SDN , BSP_GPIO_PIN_E42_SDN , RESET) ;
    Hw3000Param.ChipState = IDLE;    
}

/*****************************************************
@function:  HW3000 ֡ṹ
@param:     hw3000_param_f: HW3000
@param:     *txbuf: HW3000ݽṹ
@return:    
*****************************************************/  
int8_t Hw3000_frame_tx( Hw3000Param_t hw3000_param_f, Hw3000Data_t *txbuf)
{
	uint16_t reg_val,i=0;
	if (txbuf->len > 252)
    {
		return -1;
	}
	
	if (Hw3000Param.ChipState != TX)
    {
        Hw3000Param.ChipState = TX;
        
		Hw3000_Write_Reg(TRCTRL, 0x0100); 	                    //tx_enable
		Hw3000_Write_Reg(FIFOSTA, 0x0100);                      //flush fifo
		Hw3000_Write_Buff(FIFODATA, txbuf->data, txbuf->len);   //write fifo
		Hw3000_Write_Reg(FIFOCTRL, 0x0001);                     //ocpy = 1
		
		Hw3000_irq_request = 0;
        
                while ((!Hw3000_irq_request)&&(i<100)){
                  Ebyte_Port_DelayMs(1);
                  i++;
                  
                };                            //wait for send finish
                //DEBUG("i=%d\r\n",i);
		Hw3000_irq_request = 0;
		Hw3000Param.ChipState = IDLE;
		
		if (hw3000_param_f.ChipParam.Ack_mode == ENABLE)
        {
			reg_val = Hw3000_Read_Reg(INTFLAG);            
			if (reg_val & 0x0002) 
            {
				Hw3000_Write_Reg(FIFOCTRL, 0x0000);             //ocpy = 0
				Hw3000_Write_Reg(INTIC, 0x0001); 	            //clr_int
				Hw3000_Write_Reg(TRCTRL, 0x0000); 	            //send disable			
				return -1;
			}
		}
		Hw3000_Write_Reg(FIFOCTRL, 0x0000);                     //ocpy = 0
		Hw3000_Write_Reg(INTIC, 0x0001); 	                    //clr_int
		Hw3000_Write_Reg(TRCTRL, 0x0000); 	                    //send disable
		//if (i>=100){Hw3000_Init();};
		return 0;
	}
	return -1;
}

/*****************************************************
@function:  HW3000 ֱFIFO
@param:     hw3000_param_f: HW3000
@param:     *txbuf: HW3000ݽṹ
@return:    
*****************************************************/   
int8_t Hw3000_fifo_tx( Hw3000Param_t hw3000_param_f, Hw3000Data_t *txbuf)
{	
    if (txbuf->len > HW3000_BUF_LEN)
    {
		return -1;
	}
    
    if (Hw3000Param.ChipState != TX )
    {
		Hw3000Param.ChipState = TX;
		
		Hw3000_Write_Reg(TRCTRL, 0x0100); 	                    //tx_enable
		Hw3000_Write_Reg(FIFOSTA, 0x0108);                      //flush fifo
        
	    Hw3000_Write_Buff(FIFODATA, txbuf->data, txbuf->len);   //write fifo
		Hw3000_Write_Reg(FIFOCTRL, 0x0001);                     //ocpy = 1
        Hw3000_irq_request = 0;
        while (!Hw3000_irq_request);                            //wait for send finish
        
        Hw3000_irq_request = 0;    	
		Hw3000Param.ChipState = IDLE;		

		Hw3000_Write_Reg(FIFOCTRL, 0x0000);                     //ocpy = 0
		Hw3000_Write_Reg(INTIC, 0x0001);                        //clr_int
		Hw3000_Write_Reg(TRCTRL, 0x0000);                       //send disable			
	    return 0;
	}
	
	return -1;
}

/*****************************************************
@function:  HW3000
@param:     hw3000_param_f: HW3000
@param:     *txbuf: HW3000ݽṹ
@return:    
*****************************************************/  
int8_t Hw3000_tx_data( Hw3000Param_t hw3000_param_f, Hw3000Data_t *txbuf)
{	
	if (hw3000_param_f.ChipParam.FrameMode == FRAME ) 
    {
		return Hw3000_frame_tx( hw3000_param_f , txbuf);
	} 
    else 
    {
		return Hw3000_fifo_tx( hw3000_param_f , txbuf);
	}
}

/*****************************************************
@function:  HW3000
@param:     hw3000_param_f:Hw3000
@param:     *rxbuf: HW3000
@return:    
*****************************************************/  
int8_t Hw3000_rx_data( Hw3000Param_t hw3000_param_f, Hw3000Data_t *rxbuf)
{
    uint16_t reg;

    if (hw3000_param_f.ChipState == RX) 
    {
        if (hw3000_param_f.ChipParam.FrameMode == FRAME ) 
        {
            reg = Hw3000_Read_Reg(FIFOCTRL);
            if (!(reg & 0xC000)) //PHR CRC check
            {   
                rxbuf->len = Hw3000_Read_Reg(RXPHR0);
                rxbuf->len = ((rxbuf->len >> 8) - 3) & 0x00FF;
                Hw3000_Read_Buff(FIFODATA, rxbuf->data, rxbuf->len);
                
                Hw3000_State_Set( RXDisable );
                Hw3000_State_Set( RXEnable);
                
                return 0;
            }
            else
            {
                Hw3000_State_Set( RXDisable );
                Hw3000_State_Set( RXEnable);
                return -1;
            }
        } 
        else 
        {
            Hw3000_Read_Buff(FIFODATA,rxbuf->data, 1);              //ȡЧس
            rxbuf->len = rxbuf->data[0]-1;
            Hw3000_Read_Buff(FIFODATA, rxbuf->data, rxbuf->len);
        }         
        Hw3000_State_Set( RXDisable );
        Hw3000_State_Set( RXEnable);
        
        return 0;
    } 
    else
        return -1;
}

/*--------*/
void Hw3000_SendDat( uint8_t *buff, uint16_t len )
{
    Hw3000_State_Set( RXDisable );                //˳״̬ -- ϣȻл״̬
    
    if( Hw3000Param.ChipParam.FrameMode == FRAME )       //֡ṹ
    {
        __memcpy( Hw3000_data_buf.data, buff, len );
        Hw3000_data_buf.len = len;
    }
    else if( Hw3000Param.ChipParam.FrameMode == FIFO ) 
    {        
        __memcpy( &Hw3000_data_buf.data[1], buff, len );
        Hw3000_data_buf.len = len + 1;
        Hw3000_data_buf.data[0] = Hw3000_data_buf.len;  //Чصĳ
    }
    
    Hw3000Param.RFState=TX_RUN; 
    
    if ( Hw3000_tx_data( Hw3000Param, &Hw3000_data_buf) == 0) 
    { 
        Hw3000_State_Set( RXEnable);
        Hw3000Param.RFState = RX_RUN;      //Ժл״̬
    }
    else
    {
       Hw3000_State_Set( RXEnable);
        Hw3000Param.RFState = RX_RUN;      //ʧܺҲл״̬
    }
}
