#ifndef _HW3000_H_
#define _HW3000_H_

//#include <stdint.h>
#include <stm8l15x.h>
//#include "ddl.h"
#include "HW3000_REG.h"
//#include "Drv_Spi.h"
#include "ebyte_core.h"
#include "ebyte_callback.h"
#define VTB07_V5_0 1
#define VTB10_V5_0 2

#define TEST_BOARD_VER  VTB10_V5_0                      //˾ĲԵذͺ
            
#if ( TEST_BOARD_VER == VTB10_V5_0)             
            
#define HW3_PDN_Port                3                   //Power Downʹ
#define HW3_PDN_Pin                 4           
                    
#define HW3_IRQ_Port                2                   //ж
#define HW3_IRQ_Pin                 6           
            
#elif ( TEST_BOARD_VER == VTB07_V5_0 )          
#define HW3_PDN_Port                1                   //Power Downʹ
#define HW3_PDN_Pin                 5           
                    
#define HW3_IRQ_Port                2                   //ж
#define HW3_IRQ_Pin                 6
#endif

#define	HW3000_BUF_LEN	            255
            
#define ENABLE                      1
#define DISABLE                     0

#define BASE_FREQ                   433                 //ʼƵ
#define CHAN_SPACE                  CH_SPACE_800K       //ŵ

//ݰ
typedef struct {
	uint8_t  data[HW3000_BUF_LEN];
	uint16_t len;
} Hw3000Data_t;

//ŵ
typedef enum{
    CH_SPACE_100K = 0,
    CH_SPACE_200K = 1,
    CH_SPACE_400K = 2,
    CH_SPACE_800K = 3,
}ChSpace_e;

//ĸƵ
typedef enum {                  
	OSC20M_FREQ_235_291MHZ  = 0,
	OSC20M_FREQ_285_350MHZ  = 1,
	OSC20M_FREQ_350_437MHZ  = 2,
	OSC20M_FREQ_428_522MHZ  = 3,
	OSC20M_FREQ_700_874MHZ  = 4,
    OSC20M_FREQ_856_1045MHZ = 5, 
    
	OSC26M_FREQ_270_291MHZ  = 6,
	OSC26M_FREQ_285_348MHZ  = 7,
	OSC26M_FREQ_403_437MHZ  = 8,
	OSC26M_FREQ_428_522MHZ  = 9,
	OSC26M_FREQ_806_874MHZ  = 10,
    OSC26M_FREQ_856_1045MHZ = 11,
}FreqLevel_e;

//Ƶ
typedef enum{
    OSC20MHZ = 1,
    OSC26MHZ,
}OscFreq_e;

//Ƶģʽ
typedef enum {          
	DEFAULT = 0,                            //Ĭģʽֻ֧433MƵ
	DIRECT = 1                              //ֱģʽκƵ
} FreaSetMode_e;

//֡ṹ                               
typedef enum {                              
	FIFO = 0,                               //ֱFIFO֡ṹ
	FRAME = 1                               //ǿ֡ṹ
} FrameMode_e;

//ǰ
typedef struct{
    uint8_t Type;                           //ͣ0XAA,0X55
    uint16_t Len;                           //
}Preamble_t;

//PPL·
typedef enum{
    BW50K = 0,
    BW75K = 1,
    BW100K = 2,
    BW150K = 3,
}PllLpfr_e;

//
typedef struct
{
    OscFreq_e       Oscfreq;                //Ƶ
    FreqLevel_e     FreqLev;                //Ƶ
    FreaSetMode_e   FreqSetMode;            //Ƶģʽ
    FrameMode_e     FrameMode;              //֡ṹ
    ChSpace_e       ChSpace;                //ŵ
    uint8_t         Ack_mode;               //Ӧģʽ,0 disable, 1 enable        
    uint8_t         tx_mode;
    uint8_t         rx_mode;
}ChipParam_t;

//ͨŲ
typedef struct
{
    uint16_t        BaseFreq;               //Ƶ  
    Preamble_t      PreambleParam;          //ǰ
    int8_t          TxPower;                //͹
    float           Rate;                   //   
    uint8_t         Chan;                   //ŵ    
}TransmitParam_t;

//оƬ״̬
typedef enum {
	POWER_DOWN = 0,                         //
	DEEP_SLEEP = 1,                         //˯
	SLEEP = 2,                              //˯״̬
	IDLE = 3,                               //״̬
	TX = 4,                                 //
	RX = 5                                  //
} ChipState_e;

//ͨ״̬               
typedef enum{                       
    TX_INIT,                                //״̬ʼ
    TX_RUN,                                 //ڷ
    TX_DONE,                                //
    TX_TIMEOUT,                             //ͳʱ
                    
    TX_ACK_INIT,
    
    RX_INIT,                                //ճʼ
    RX_RUN,                                 //ս
    RX_DONE,                                //
                    
    RX_ACK_INIT,                            //Ӧʼ
    RX_ACK_DONE,                            //Ӧ
    RX_TIMEOUT,                             //ճʱ    
}RFState_e;

//״̬л
typedef enum{
    PowerDownEnable = 1,                    //ģʽ
    PowerDownDisable,                       //ӵģʽָIDLEģʽ
    DeepSleepEnable,                        //˯ģʽ
    DeepSleepDisable,                       //˯ģʽָIDLEģʽ
    SleppEnable,                            //˯ģʽ
    SleepDisable,                           //˯ģʽ˳IDLEģʽ
    TXEnable,                               //ʹܷ
    TXDisable,                              //ʧܷ
    RXEnable,                               //ʹܽ
    RXDisable,                              //ʧܽ
} WorkMode_e; 

typedef struct{
    ChipParam_t         ChipParam;          //
    TransmitParam_t     TransmitParam;      //ͨŲ
    ChipState_e         ChipState;          //оƬ״̬
    RFState_e           RFState;            //ͨ״̬
}Hw3000Param_t;

extern Hw3000Param_t        Hw3000Param;                //Hw3000
extern Hw3000Data_t         Hw3000_data_buf;            //HW3000ݰ
extern volatile uint8_t     Hw3000_irq_request;         //request for irq

void Hw3000_GPIO_Init( void );                                                      //HW3000 GPIOʼ

void Hw3000_Write_Reg( uint8_t addr, uint16_t halfWord );                           //дHW3000Ĵ
uint16_t Hw3000_Read_Reg( uint8_t addr );                                           //ȡHW3000Ĵ
void Hw3000_Write_Buff(uint8_t addr, uint8_t *WriteBuff, uint16_t length);
void Hw3000_Read_Buff(uint8_t addr, uint8_t *ReadBuff, uint16_t length);

void Hw3000_Osc_Set( OscFreq_e osc_fe );                                            //þƵ
uint8_t Hw3000_Check_Spi( void );                                                   //SPIͨǷ
void Hw3000_Soft_Reset0( void );                                                    //λ0
void Hw3000_Soft_Reset1( void );                                                    //λ1
uint16_t Hw3000_Read_IntFlag( void );                                               //ȡжϱ־
void  Hw3000_Clear_IntFlag( uint16_t IntFlag );                                     //жϱ־
uint16_t Hw3000_Read_ChipSta0( void );      
void Hw3000_State_Set( WorkMode_e Work_Mode ) ;                                     //HW3000״̬
void Hw3000_TxPower_Set( int8_t Power);                                             //书
void Hw3000_Frame_Set( FrameMode_e frame_mode);                                     //֡ṹ
void Hw3000_Rate_Set( float fRate);                                                 //
void Hw3000_BaseFreq_Set( uint16_t baseFreq );                                      //Ƶ
void Hw3000_ChSpace_Set( ChSpace_e ch_space );                                      //ŵ
void Hw3000_Channel_Set( uint8_t channel );                                         //ź

void Hw3000_Init( void  );                                                          //HW3000 ʼ
int8_t Hw3000_tx_data( Hw3000Param_t hw3000_param_f, Hw3000Data_t *txbuf);          //HW3000 
int8_t Hw3000_rx_data( Hw3000Param_t hw3000_param_f, Hw3000Data_t *rxbuf);          //HW3000 
void Hw3000_tx_0101(void);
void Hw3000_cancel_0101(void);
void Hw3000_SendDat( uint8_t *buff, uint16_t len );
void E42x_GoReceive(void);
uint8e_t* E42x_GetName(void);
uint8_t E42x_TaskForPoll(void);
uint8e_t E42x_GetDriverVersion(void);
#endif

